"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const formatWarn_1 = __importDefault(require("./utils/formatWarn"));
const zooming_1 = require("./utils/zooming");
const most = require("most");
exports.default = (installCheck$, opts) => {
    return installCheck$
        .map(formatInstallCheck.bind(null, opts.cwd))
        .filter(Boolean)
        .map((msg) => ({ msg }))
        .map(most.of);
};
function formatInstallCheck(currentPrefix, logObj, opts) {
    var _a;
    const zoomOutCurrent = (_a = opts === null || opts === void 0 ? void 0 : opts.zoomOutCurrent) !== null && _a !== void 0 ? _a : false;
    switch (logObj.code) {
        case 'EBADPLATFORM':
            return zooming_1.autozoom(currentPrefix, logObj['prefix'], formatWarn_1.default(`Unsupported system. Skipping dependency ${logObj.pkgId}`), { zoomOutCurrent });
        case 'ENOTSUP':
            return zooming_1.autozoom(currentPrefix, logObj['prefix'], logObj.toString(), { zoomOutCurrent });
        default:
            return undefined;
    }
}
//# sourceMappingURL=reportInstallChecks.js.map